#include <iostream>
#include <ogr_geometry.h>

int main()
{
    OGRLineString *line = new OGRLineString();
    std::cout << line->IsConvex() << std::endl; // gives true
    //line->get_IsClosed(); // assertion failure (#1)

    line->addPoint(0, 0);
    std::cout << line->IsConvex() << std::endl; // gives true
    std::cout << line->get_IsClosed() << std::endl; // gives true

    // counter-clockwise one-sided square (not closed)
    line->addPoint(1, 0);
    line->addPoint(1, 1);
    line->addPoint(0, 1);

    std::cout << line->IsConvex() << std::endl; // gives false (#2)
    std::cout << line->get_IsClosed() << std::endl; // gives false (ok)

    line->addPoint(0, 0); // close ring
    std::cout << line->IsConvex() << std::endl; // gives false (#2)
    std::cout << line->get_IsClosed() << std::endl; // gives true (ok)

    line->reversePoints(); // make it clockwise
    std::cout << line->IsConvex() << std::endl; // gives true (ok)
    std::cout << line->get_IsClosed() << std::endl; // gives true (ok)

    return 0;
}
